## condor 8.4.2~dfsg.1

=== CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright 2011 Red Hat, Inc. 
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 

##########################################################################
# Set project
project(CONDOR)
cmake_minimum_required(VERSION 2.6)

##########################################################################
#Setup package meta-data (used in packaging)
set(PACKAGE "condor")

# Condor version info
#   Condor and other systems parse this number. Keep it simple:
#   Number.Number.Number. Do nothing else.  If you need to add
#   more information, PRE_RELEASE is usually the right location.
set(VERSION "8.4.2")

# Set PRE_RELEASE to either a string (i.e. "PRE-RELEASE-UWCS") or OFF
#   This shuld be "PRE-RELEASE-UWCS most of the time, and OFF when
#   building a release candidate.  If you need to identify builds,
#   perhaps because you are working on a feature branch and need to
#   ship test binaries to a user, change this to identify your work.
#   Avoid whitespace.
#set(PRE_RELEASE "PRE-RELEASE-UWCS")
set(PRE_RELEASE OFF)

# If set via the cmake command line, FORCE_PRE_RELEASE allows for
#   PRE_RELEASE to be forced into a build.
#   cmake ... -DFORCE_PRE_RELEASE:STRING=PRE-RELEASE-NMI
if( FORCE_PRE_RELEASE )
  set(PRE_RELEASE ${FORCE_PRE_RELEASE})
endif( FORCE_PRE_RELEASE )

set(PACKAGE_BUGREPORT "http://condor-wiki.cs.wisc.edu/index.cgi/tktnew")
set(PACKAGE_NAME ${PACKAGE} )
set(PACKAGE_VERSION ${VERSION} )
set(PACKAGE_STRING ${PACKAGE} )
string( TOUPPER "${CMAKE_SYSTEM_NAME}" OS_NAME )
string( TOUPPER "${CMAKE_SYSTEM_VERSION}" OS_VER )
string( TOUPPER "${CMAKE_SYSTEM_PROCESSOR}" SYS_ARCH )
site_name(HOSTNAME)
option(_DEBUG "Debug statements and set default build config" OFF)

###########################################
# start cmake module inclusion
list(APPEND CMAKE_MODULE_PATH ${CONDOR_SOURCE_DIR}/build/cmake/macros;${CONDOR_SOURCE_DIR}/build/cmake/modules;${CONDOR_SOURCE_DIR}/build/cmake)

include (dprint) # set debug module 1st to all spewing in other modules if needed
include (AppendVar)
include (CommandTarget)
include (gSOAPGen)
include (CloneInstall)
include (FindMultiple)
include (FindSoName)
include (ExternalProject)
include (CheckIncludeFiles)
include (CheckFunctionExists)
include (CheckSymbolExists)
include (CheckStructHasMember)
include (CheckTypeExists)
include (CheckLibraryExists)
include (CheckTypeSize)
include (GetTimeDate)
include (CleanString)
include (PackageDate)
include (SystemSpecificInformations)
include (CondorPackageConfig) # setup packaging variables needed prior to install targets
include (CondorGlob)
include (CondorSelectiveGlob)
include (CondorSetLinkLibs)
include (CondorExe)
include (CondorDaemon)
include (CondorPrecompiledHeaders)
include (CondorStaticLib)
include (CondorPlugin)
include (CheckCCompilerFlag)
include (CheckCXXCompilerFlag)
include (CheckCXXSourceCompiles)
include (AddSubdirectories)
include (CTest)
include (CondorPLTest)
include (CondorExeTest)
include (CondorUnitTest)
include (CondorStdExeTest)
include (SrcTargetRef)
include (DumpLocalFlags)
include (CondorPreExternal)
include (CondorPostExternal)
include (CondorConfigure)     # will initiate the configure
include (TarGz) # Must be after include(CondorPackageConfig)

if ( WINDOWS )
	set_property(GLOBAL PROPERTY USE_FOLDERS ON)
endif ( WINDOWS )
##########################################################################
# we only include the single sub to allow make at two levels.
# root - includes externals
# src - src -> only
# this way clean @ root cleans externals while clean @src cleans just the src.
add_subdirectory (src)
add_subdirectory (build/packaging)

##########################################################################
# the following are existing doc targets
# ideally one would transform the building of the docs to cmake or a script

# logic here to support old nmi builds
if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/doc/man")

	if (NOT WANT_MAN_PAGES OR ${LATEX} STREQUAL "LATEX-NOTFOUND" OR ${LATEX2HTML} STREQUAL "LATEX2HTML-NOTFOUND")
		message(STATUS "NOTE: Skipping man-pages")
	else()
		
		message(STATUS "NOTE: Will try building man-pages")
		# NOTE: deps are not configured to detect file changes.
		add_custom_command (OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/doc/man/man1/condor_on.1
						COMMAND make
						ARGS just-man-pages
						WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/doc )
						#DEPENDS )

		add_custom_target ( docs ALL DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/doc/man/man1/condor_on.1 )
		
		install( DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/doc/man/ DESTINATION ${C_MAN} )
	endif()

else()
	message(STATUS "NOTE: Will install prebuilt man-pages")
	#Use trailing slash; otherwise, it will be C_MAN/man
	install( DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/doc/man/ DESTINATION ${C_MAN} )
endif()

##########################################################################
# Must in included post *install targets
include ( CPack )

=== doc/Makefile ===
# we expect grep to return set(VERSION "x.y.z")
# we use $subst to convert () and " to spaces and then $word to extract x.y.z
VERLINE = $(shell grep set.VERSION ../CMakeLists.txt)
VERTEMP = ${word 3,${subst ",,${subst ),,${subst (, ,${VERLINE}}}}}
SUBDIR  = v$(VERTEMP)
SUBVER  = V$(subst .,_,$(VERTEMP))
MANDIR = /p/condor/public/html/htcondor/manual/$(SUBDIR)
TARGETDIR = $(MANDIR).new
LOCALDIR = ref-$(SUBDIR)
MANPAGES = $(shell grep '^\\input' man-pages/man.tex | grep -v tool_common.tex | awk -F/ '{print $$2}' | awk -F. '{printf "%s.html ",$$1}')

# NOTE: older latex versions do not support -halt-on-error
#       including /p/condor/workspaces/build/bin/latex, unfortunately
LATEXARGS := -file-line-error-style $(shell latex --help | grep -o -- -halt-on-error)

all:  ref.dvi
#all:  man.ps

ref.pdf: clean
	echo "\usepackage{times} \usepackage[latex2html,ps2pdf,bookmarks,bookmarksnumbered,plainpages=false,pdfpagelabels]{hyperref}" > timesfont.tex
	rm -f fontsize.tex
	rm -f symbol.tex
	rm -f figuresizing.tex
	ln -s regularfont.tex fontsize.tex
	ln -s symbol-postscript.tex symbol.tex
	ln -s figuresizing-latex.tex figuresizing.tex
	make figures
	latex $(LATEXARGS)  ref.tex
	latex $(LATEXARGS)  ref.tex
	latex $(LATEXARGS)  ref.tex
	latex $(LATEXARGS)  ref.tex
	latex $(LATEXARGS)  ref.tex
	makeindex ref
	latex $(LATEXARGS)  ref.tex
	rm -f ref.ps
	dvips ref.dvi -o ref.ps
	rm -f ref.pdf
	gs -sDEVICE=pdfwrite -sOutputFile=ref.pdf -dNOPAUSE -dBATCH ref.ps
	rm -f ref.dvi
	rm -f ref.ps

release-pdf: ref.pdf $(TARGETDIR)
	cp ref.pdf $(TARGETDIR)/condor-$(SUBVER)-Manual.pdf

ref.dvi: clean
	echo "% do not want times" > timesfont.tex
	rm -f fontsize.tex
	rm -f symbol.tex
	rm -f figuresizing.tex
	ln -s smallfont.tex fontsize.tex
	ln -s symbol-postscript.tex symbol.tex
	ln -s figuresizing-latex.tex figuresizing.tex
	make figures
	latex $(LATEXARGS) ref.tex
	latex $(LATEXARGS) ref.tex
	latex $(LATEXARGS) ref.tex
	latex $(LATEXARGS) ref.tex
	latex $(LATEXARGS) ref.tex
	makeindex ref
	latex $(LATEXARGS) ref.tex

ref.ps: ref.dvi
	dvips ref.dvi -o ref.ps

release-ps: ref.ps $(TARGETDIR)
	cp ref.ps $(TARGETDIR)/ref.ps
	cp $(TARGETDIR)/ref.ps $(TARGETDIR)/condor-$(SUBVER)-Manual.ps
	compress $(TARGETDIR)/condor-$(SUBVER)-Manual.ps
	cp $(TARGETDIR)/ref.ps $(TARGETDIR)/condor-$(SUBVER)-Manual.ps
	gzip $(TARGETDIR)/condor-$(SUBVER)-Manual.ps
	mv $(TARGETDIR)/ref.ps $(TARGETDIR)/condor-$(SUBVER)-Manual.ps

ref.html: clean $(TARGETDIR)
	echo "% do not want times" > timesfont.tex
	rm -f fontsize.tex
	rm -f symbol.tex
	rm -f figuresizing.tex
	ln -s regularfont.tex fontsize.tex
	ln -s symbol-html.tex symbol.tex
	ln -s figuresizing-html.tex figuresizing.tex
	make figures
	latex $(LATEXARGS)  ref.tex
	latex $(LATEXARGS)  ref.tex
	latex $(LATEXARGS)  ref.tex
	latex $(LATEXARGS)  ref.tex
	latex $(LATEXARGS)  ref.tex
	makeindex ref
	latex $(LATEXARGS)  ref.tex
	latex2html -split 4 -link 2 -show_section_numbers -antialias -tmp /tmp -long_titles 3 -toc_depth 2 -local_icons ref.tex
	cd ref && perl -pi.bak -e 's,\<HEAD\>,<HEAD>\n<link rel="canonical" href="http://research.cs.wisc.edu/htcondor/manual/current/$$ARGV">\n,' condor_*.html
	rm -f ref.dvi
	mv ref condor-$(SUBVER)-Manual
	tar cvf condor-$(SUBVER)-Manual.tar condor-$(SUBVER)-Manual

	gzip -c condor-$(SUBVER)-Manual.tar > condor-$(SUBVER)-Manual.tar.gz
	compress condor-$(SUBVER)-Manual.tar

	mv condor-$(SUBVER)-Manual.tar.gz condor-$(SUBVER)-Manual
	mv condor-$(SUBVER)-Manual.tar.Z condor-$(SUBVER)-Manual

	mv condor-$(SUBVER)-Manual ref.new

	mv -f ref.new/* $(TARGETDIR)
	rmdir ref.new
	touch ref.html

local.html: $(wildcard *.tex) $(wildcard */*.tex)
	echo "% do not want times" > timesfont.tex
	rm -f fontsize.tex
	rm -f symbol.tex
	rm -f figuresizing.tex
	ln -s regularfont.tex fontsize.tex
	ln -s symbol-html.tex symbol.tex
	ln -s figuresizing-html.tex figuresizing.tex
	make figures
	latex $(LATEXARGS)  ref.tex
	latex $(LATEXARGS)  ref.tex
	latex $(LATEXARGS)  ref.tex
	latex $(LATEXARGS)  ref.tex
	latex $(LATEXARGS)  ref.tex
	makeindex ref
	latex $(LATEXARGS)  ref.tex
	latex2html -split 4 -link 2 -show_section_numbers -antialias -tmp /tmp -long_titles 3 -toc_depth 2 -local_icons ref.tex
	rm -rf $(LOCALDIR)
	mv    ref $(LOCALDIR)
	touch local.html

release-html: ref.html $(TARGETDIR)
	rm -rf $(MANDIR).old
	touch $(MANDIR)
	mv -f $(MANDIR) $(MANDIR).old
	mv -f $(TARGETDIR) $(MANDIR)
	rm -f ref.html

admin-man/pool-arch.eps: admin-man/pool-arch.fig
	rm -f $@
	fig2dev -L eps -m .4 $< > $@

user-man/dagman-diamond.eps: user-man/dagman-diamond.fig
	rm -f $@
	fig2dev -L eps -m .6 $< > $@

figures: admin-man/states.eps admin-man/activities.eps admin-man/pool-arch.eps user-man/dagman-diamond.eps 


$(TARGETDIR):
	mkdir $(TARGETDIR)

clean:
	rm -rf $(LOCALDIR) ref ref.new man user admin *.1 *.dvi *.ps *.html *.log *.aux *.toc *.pdf */*.log *.ind *.idx *.ilg timesfont.tex user-man/dagman-diamond.eps admin-man/pool-arch.eps *.out
	cd makeman; make clean

reallyclean: clean
	rm -rf $(TARGETDIR)

release:
	make reallyclean
	make release-ps
	make release-pdf
	make release-html

.PHONY: just-man-pages

just-man-pages:
	echo "% do not want times" > timesfont.tex
	rm -f fontsize.tex
	rm -f symbol.tex
	rm -f figuresizing.tex
	ln -s regularfont.tex fontsize.tex
	ln -s symbol-html.tex symbol.tex
	ln -s figuresizing-html.tex figuresizing.tex
	cd makeman && make clean makeman
	latex2html -split 4 -link 2 -show_section_numbers -antialias -tmp /tmp -long_titles 3 -toc_depth 2 -local_icons just-man-pages.tex
	for html in $(MANPAGES); do \
		thisfile=just-man-pages/$$html; \
		makeman/makeman -v -i $$thisfile -s 1; \
	done
	-mkdir man
	-mkdir man/man1
	mv just-man-pages/*.1 man/man1

=== src/CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright 2011 Red Hat, Inc. 
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 

##########################################################################
# adds all subtree elements which have a CMakeLists.txt file exclude
# classads b/c we added earlier to elim externals dependency - all externals reference
# one version of classads which is ${CONDOR_SOURCE_DIR}/src/classad

# the 2nd arg is prio order for symbols ripping to prevent .o copy-mindging within the std:u
add_subdirectories("${CONDOR_SOURCE_DIR}/src"
	"${CONDOR_SOURCE_DIR}/src/classad_analysis;${CONDOR_SOURCE_DIR}/src/ccb;${CONDOR_SOURCE_DIR}/src/condor_io;${CONDOR_SOURCE_DIR}/src/condor_ckpt_server;${CONDOR_SOURCE_DIR}/src/condor_daemon_client;${CONDOR_SOURCE_DIR}/src/condor_daemon_core.V6;${CONDOR_SOURCE_DIR}/src/condor_privsep;${CONDOR_SOURCE_DIR}/src/condor_procapi;${CONDOR_SOURCE_DIR}/src/condor_procd;${CONDOR_SOURCE_DIR}/src/condor_schedd.V6;${CONDOR_SOURCE_DIR}/src/condor_sysapi;${CONDOR_SOURCE_DIR}/src/condor_utils;${CONDOR_SOURCE_DIR}/src/condor_ckpt;${CONDOR_SOURCE_DIR}/src/condor_io.std;${CONDOR_SOURCE_DIR}/src/condor_syscall_lib"
	"${CONDOR_SOURCE_DIR}/src/classad;${CONDOR_SOURCE_DIR}/src/safefile")

#if (BUILD_TESTING AND NOT WINDOWS)
if (BUILD_TESTING)
	if (WINDOWS)
		add_custom_target( BLD_TESTS )
		add_dependencies( BLD_TESTS ${CONDOR_TESTS} )
	else(WINDOWS)
		add_custom_target(tests)
		add_dependencies(tests ${CONDOR_TESTS})
	endif(WINDOWS)
	dprint("CONDOR_TESTS=${CONDOR_TESTS}")
endif()

if (WANT_FULL_DEPLOYMENT)
	install ( FILES condor_includes/condor_classad.h
			  condor_includes/condor_constants.h
			  condor_includes/condor_header_features.h
			  condor_includes/file_lock.h
			  condor_utils/iso_dates.h
			DESTINATION ${C_INCLUDE})
endif(WANT_FULL_DEPLOYMENT)

=== src/ccb/CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright 2011 Red Hat, Inc. 
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 

condor_glob(ccbHdrs ccbSrcs "")
set( CCB_UTIL_SRCS "${ccbHdrs};${ccbSrcs}" PARENT_SCOPE )

=== src/classad/CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright 2011 Red Hat, Inc. 
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 
 
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/classad/classad_stl.h.in ${CMAKE_CURRENT_BINARY_DIR}/classad/classad_stl.h.tmp)
# only update config.h if it is necessary b/c it causes massive rebuilding.
exec_program ( ${CMAKE_COMMAND} ARGS -E copy_if_different ${CMAKE_CURRENT_BINARY_DIR}/classad/classad_stl.h.tmp ${CMAKE_CURRENT_BINARY_DIR}/classad/classad_stl.h )
 
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${BOOST_INCLUDE})

# disable PCRE build unless dep added to externals.
if(PCRE_FOUND)
	include_directories(${PCRE_INCLUDE})
	add_definitions(-DUSE_PCRE)
	if(HAVE_PCRE_H)
		add_definitions(-DHAVE_PCRE_H)
	elseif(HAVE_PCRE_PCRE_H)
		add_definitions(-DHAVE_PCRE_PCRE_H)
	endif()
else()
	add_definitions(-DUSE_POSIX_REGEX) 
endif(PCRE_FOUND)

if (HAVE_DLOPEN)
	add_definitions(-DHAVE_DLOPEN)
endif()

if (HAVE_DLFCN_H)
	add_definitions(-DHAVE_DLFCN_H)
endif()

if (HAVE_LIBDL)
	set (DL_FOUND -ldl)
endif (HAVE_LIBDL)

dprint("classad_BOOST_INCLUDE=${BOOST_INCLUDE}")

if ( ${PACKAGE_VERSION} MATCHES "([0-9]+)[.]([0-9]+)[.]([0-9]+)" )
	add_definitions( -DCLASSAD_VERSION="${PACKAGE_VERSION}"
		-DCLASSAD_VERSION_MAJOR=${CMAKE_MATCH_1}
		-DCLASSAD_VERSION_MINOR=${CMAKE_MATCH_2}
		-DCLASSAD_VERSION_PATCH=${CMAKE_MATCH_3} )
endif()

file( GLOB Headers classad/*.h )
set( Headers "${Headers};${CMAKE_CURRENT_BINARY_DIR}/classad/classad_stl.h" )

##
#####################################################################

#####################################################################
# treat like an external for others to use
condor_pre_external( CLASSADS classads-${PACKAGE_VERSION} "lib;include" "alwaysbuild")
#####################################################################

if (NOT WINDOWS)

  condor_selective_glob("attrrefs.*;classad.*;classadCache.*;collection.*;collectionBase.*;debug.*;exprList.*;exprTree.*;fnCall.*;indexfile.*;lexer.*;lexerSource.*;literals.*;matchClassad.*;operators.*;query.*;sink.*;source.*;transaction.*;util.*;value.*;view.*;xmlLexer.*;xmlSink.*;xmlSource.*;cclassad.*;common.*" ClassadSrcs)
  add_library( classads STATIC ${ClassadSrcs} )    # the one which all of condor depends upon
  set_target_properties( classads PROPERTIES OUTPUT_NAME classad )

  if (LINUX OR DARWIN)  
  	add_library( classad SHARED ${ClassadSrcs} )   # for distribution at this point may swap to depend at a future date.
	set_target_properties( classad PROPERTIES VERSION ${PACKAGE_VERSION} SOVERSION 7 )
	condor_set_link_libs( classad "${PCRE_FOUND};${DL_FOUND}" )
	install( TARGETS classad DESTINATION ${C_LIB_PUBLIC} )
  endif()
  if ( DARWIN )
	add_custom_command( TARGET classad
		POST_BUILD
		WORKING_DIRECTORY ${CLASSADS_INSTALL_LOC}/lib
		COMMAND ${CMAKE_SOURCE_DIR}/src/condor_scripts/macosx_rewrite_libs libclassad.${PACKAGE_VERSION}.dylib )
  endif()

  if ( LINUX OR DARWIN )
	# set external reference to the shared library for linux
	set (CLASSADS_FOUND classad)
	set (CLASSADS_FOUND_STATIC classads)
  else()
	# set external reference to the static library for non-linux
	set (CLASSADS_FOUND classads)
	set (CLASSADS_FOUND_STATIC classads)
  endif()

  ##condor_exe( classad_functional_tester "classad_functional_tester.cpp" ${C_BIN} "${CLASSADS_FOUND};${PCRE_FOUND};${DL_FOUND}" OFF)
  add_executable( classad_functional_tester "classad_functional_tester.cpp" )
  condor_set_link_libs( classad_functional_tester "${CLASSADS_FOUND};${PCRE_FOUND};${DL_FOUND}")
  install (TARGETS classad_functional_tester DESTINATION ${C_BIN} )
  
  ##condor_exe( classad_version "classad_version.cpp" ${C_BIN} "${CLASSADS_FOUND};${PCRE_FOUND};${DL_FOUND}" OFF)
  add_executable( classad_version "classad_version.cpp" )
  condor_set_link_libs( classad_version "${CLASSADS_FOUND};${PCRE_FOUND};${DL_FOUND}")
  install (TARGETS classad_version DESTINATION ${C_BIN} )
  
  ###### Install elements with our distribution
  install( TARGETS classads DESTINATION ${C_LIB_PUBLIC} )
  install( FILES ${Headers} DESTINATION ${C_INCLUDE_PUBLIC}/classad )

else()	
	# windows specific configuration.
	condor_selective_glob("attrrefs.cpp;common.cpp;collection*;classadCache.*;fnCall.cpp;expr*;indexfile*;lexer*;literals.cpp;matchClassad.cpp;classad.cpp;debug.cpp;operators.cpp;util.cpp;value.cpp;query.cpp;sink.cpp;source.cpp;transaction.cpp;view.cpp;xml*" ClassadSrcs)
	add_library( classads STATIC ${ClassadSrcs} )
	set (CLASSADS_FOUND classads)
	set (CLASSADS_FOUND_STATIC classads)

endif()

set( CLASSADS_FOUND ${CLASSADS_FOUND} PARENT_SCOPE )
set( CLASSADS_FOUND_STATIC ${CLASSADS_FOUND_STATIC} PARENT_SCOPE )


condor_post_external( classads include OFF )

# standard output message used to slog users.  
message (STATUS "configured (CLASSADS_FOUND= ${CLASSADS_FOUND})")

# finally add dependencies if there are any
if (NOT PROPER)
  
  if(PCRE_REF)
	add_dependencies( classads ${PCRE_REF} )
  endif()

  # On Mac, we build our own pcre, unlike linux, so need to 
  # have a dependency here so we build pcre before classads
  if ( DARWIN AND PCRE_REF)
	add_dependencies( classad ${PCRE_REF} )
  endif()

  if (BOOST_REF)
	  add_dependencies( classads ${BOOST_REF} )
	  if ( LINUX OR DARWIN )
		  add_dependencies( classad ${BOOST_REF} )
	  endif()
  endif()

  if (NOT WINDOWS)
	############################################################################## 
	# the only reason this exists is b/c our externals depend on it
	# (blahp & creame)
	file( COPY ${Headers} DESTINATION ${CLASSADS_INSTALL_LOC}/include/classad )
	set_target_properties( classads
		PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${CLASSADS_INSTALL_LOC}/lib 
		LIBRARY_OUTPUT_DIRECTORY ${CLASSADS_INSTALL_LOC}/lib
		RUNTIME_OUTPUT_DIRECTORY ${CLASSADS_INSTALL_LOC}/lib
		OUTPUT_NAME classad)
	if ( LINUX OR DARWIN )
		set_target_properties( classad
			PROPERTIES ARCHIVE_OUTPUT_DIRECTORY ${CLASSADS_INSTALL_LOC}/lib 
			LIBRARY_OUTPUT_DIRECTORY ${CLASSADS_INSTALL_LOC}/lib
			RUNTIME_OUTPUT_DIRECTORY ${CLASSADS_INSTALL_LOC}/lib)
	endif()

  endif()

endif(NOT PROPER)

###### Test executables
condor_unit_test( classad_unit_tester "classad_unit_tester.cpp" "${CLASSADS_FOUND};${PCRE_FOUND};${DL_FOUND}" OFF)
add_subdirectory(tests)

=== src/condor_chirp/CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright 2011 Red Hat, Inc. 
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 



condor_static_lib( chirp_client "chirp_client.h;chirp_client.c" )
if ( CONDOR_BUILD_SHARED_LIBS )
	condor_shared_lib( chirp_client_shared "chirp_client.h;chirp_client.c" )
	set_target_properties( chirp_client_shared PROPERTIES OUTPUT_NAME chirp_client )
endif()

condor_exe( condor_chirp "condor_chirp.cpp" ${C_LIBEXEC}
"chirp_client;${CONDOR_TOOL_LIBS}" OFF )

install ( FILES Chirp.jar DESTINATION ${C_LIB} )

if (WANT_FULL_DEPLOYMENT)
    install ( FILES chirp_client.h DESTINATION ${C_INCLUDE})
    if (NOT WINDOWS)
        install (TARGETS chirp_client DESTINATION ${C_LIB})
        install (FILES chirp_client.c chirp_client.h chirp_protocol.h DESTINATION ${C_SRC}/chirp)
    endif(NOT WINDOWS)
endif (WANT_FULL_DEPLOYMENT)

=== src/condor_ckpt_server/CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright 2011 Red Hat, Inc. 
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 


condor_selective_glob("server_interface.*" ServerAPISrcs )

set( CKPT_SERVER_UTIL_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/network2.cpp;${CMAKE_CURRENT_SOURCE_DIR}/network2.h;${ServerAPISrcs}" PARENT_SCOPE )

if(STD_UNIVERSE)
	condor_glob( HeaderFiles SourceFiles "${ServerAPISrcs}" )
	condor_exe( condor_ckpt_server "${HeaderFiles};${SourceFiles}" ${C_SBIN} "${CONDOR_TOOL_LIBS}" OFF )
endif(STD_UNIVERSE)

=== src/condor_collector.V6/CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright 2011 Red Hat, Inc. 
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 


if (NOT WIN_EXEC_NODE_ONLY)

	include_directories(${CMAKE_CURRENT_BINARY_DIR})

	## create targets
	file( GLOB collectorRmvElements Example* )

	condor_selective_glob( "collector_stats.*;collector_engine.*;view_server.*;collector.*" CollectorLibSrcs)
	condor_static_lib ( collectorlib "${CollectorLibSrcs}")

	if ( DLOPEN_SECURITY_LIBS )
		condor_daemon ( collector
			"${collectorRmvElements};${CollectorLibSrcs}"
			"${CONDOR_LIBS};${GSOAP_FOUND};${LIBSSL_FOUND};${ZLIB_FOUND};${CONDOR_QMF};collectorlib"
			${C_SBIN}
			ON )
	else()
		condor_daemon ( collector
					"${collectorRmvElements};${CollectorLibSrcs}"
					"${CONDOR_LIBS};${GSOAP_FOUND};${ZLIB_FOUND};${CONDOR_QMF};collectorlib"
					${C_SBIN}
					ON )
	endif()
	if (HAVE_EXT_GSOAP)
		install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/condorCollector.wsdl DESTINATION ${C_LIB}/webservice )
	endif(HAVE_EXT_GSOAP)

	add_subdirectory(tests)

endif(NOT WIN_EXEC_NODE_ONLY)

=== src/condor_examples/CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright 2011 Red Hat, Inc. 
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 

if (NOT WINDOWS)

install(FILES		condor.sysconfig
		DESTINATION	"${C_SYSCONFIG}"
		PERMISSIONS ${CONDOR_SCRIPT_PERMS}
		RENAME		condor)

install (FILES
		condor.boot.generic
		condor_config.local.central.manager
		condor_config.local.ha_condor_client
		condor.sysconfig
		README
		condor.boot.rpm
		condor_config.local.ckpt.server
		condor_config.local.ha_condor_had
		condor_config.generic
		condor_config.generic.redhat
		condor_config.local.dedicated.resource
		condor_config.local.view_server
		#condor_config.generic.debian.patch
		condor_config.local.dedicated.submit
		condor_config.submit.generic
		#condor_config.generic.rpm.patch
		#condor_config.local.generic
		condor.init
		condor.plist
		condor_config.annotated
		DESTINATION ${C_ETC_EXAMPLES})

install (FILES
	  openmpiscript
	  mp2script
	  mp1script
	  lamscript
	 DESTINATION ${C_ETC_EXAMPLES}
	 PERMISSIONS ${CONDOR_SCRIPT_PERMS} )

install (FILES 
	condor_limits_wrapper.sh
	condor_schedd.init
	interactive.sub
	DESTINATION ${C_LIBEXEC}
	PERMISSIONS ${CONDOR_SCRIPT_PERMS})

#Prepare OS specific config file

if ( RPM_SYSTEM_NAME AND CONDOR_PACKAGE_BUILD)


	if (${BIT_MODE} MATCHES "32" OR ${SYS_ARCH} MATCHES "IA64" )	
		add_custom_command( OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/condor_config.patched
						WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
						COMMAND cp 
						ARGS ${CMAKE_CURRENT_SOURCE_DIR}/condor_config.generic condor_config.patched
						COMMAND patch 
						ARGS condor_config.patched ${CMAKE_CURRENT_SOURCE_DIR}/condor_config.generic.rpm.patch )

		add_custom_target(	patch_configurations
						ALL
						DEPENDS condor_config.patched)
		install(FILES		${CMAKE_CURRENT_BINARY_DIR}/condor_config.patched
				DESTINATION	"${C_ETC}"
				RENAME	condor_config)
	else()
		#x86_64 use /usr/lib64 instead of /usr/lib
		#we will apply 2 patches on condor_config file
		add_custom_command( OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/condor_config.patched
						WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
						COMMAND cp 
						ARGS ${CMAKE_CURRENT_SOURCE_DIR}/condor_config.generic condor_config.patched
						COMMAND patch 
						ARGS condor_config.patched ${CMAKE_CURRENT_SOURCE_DIR}/condor_config.generic.rpm.patch )

		add_custom_command( OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/condor_config.patched.x86_64
						WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
						COMMAND cp 
						ARGS ${CMAKE_CURRENT_BINARY_DIR}/condor_config.patched condor_config.patched.x86_64
						DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/condor_config.patched
						COMMAND patch 
						ARGS condor_config.patched.x86_64 ${CMAKE_CURRENT_SOURCE_DIR}/condor_config.generic.rpm64.patch )
	
		add_custom_target(	patch_configurations_x86_64
						ALL
						DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/condor_config.patched.x86_64)
		
		install(FILES	${CMAKE_CURRENT_BINARY_DIR}/condor_config.patched.x86_64
						DESTINATION	"${C_ETC}"
						RENAME	condor_config)					
	endif ()					

	install(FILES		condor.boot.rpm
			DESTINATION	"${C_INIT}"
			PERMISSIONS ${CONDOR_SCRIPT_PERMS}
			RENAME		condor)

elseif ( DEB_SYSTEM_NAME AND CONDOR_PACKAGE_BUILD)

	add_custom_command( OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/condor_config.patched
						WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
						COMMAND cp
						ARGS ${CMAKE_CURRENT_SOURCE_DIR}/condor_config.generic condor_config.patched
					    COMMAND patch
						ARGS condor_config.patched ${CMAKE_CURRENT_SOURCE_DIR}/condor_config.generic.debian.patch )

	add_custom_target(	patch_configurations
						ALL
						DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/condor_config.patched)

	install(FILES		${CMAKE_CURRENT_BINARY_DIR}/condor_config.patched
						DESTINATION	"${C_ETC}"
						RENAME	condor_config)

	#Debian init script need to be patched because /etc/sysconfig/condor -> /etc/default/condor
	add_custom_command( OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/condor.boot.debian
						WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
						COMMAND cp
						ARGS ${CMAKE_CURRENT_SOURCE_DIR}/condor.boot.rpm condor.boot.debian
						COMMAND patch
						ARGS condor.boot.debian ${CMAKE_CURRENT_SOURCE_DIR}/condor.boot.debian.patch )

	add_custom_target(	patch_init_script
						ALL
						DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/condor.boot.debian)

	install(FILES		${CMAKE_CURRENT_BINARY_DIR}/condor.boot.debian
			DESTINATION	"${C_INIT}"
			PERMISSIONS ${CONDOR_SCRIPT_PERMS}
			RENAME	condor)
else()
	#Other Platform
	install(FILES		condor_config.generic
			DESTINATION	"${C_ETC}"
			RENAME	condor_config)

	install(FILES		condor.boot.rpm
			DESTINATION	"${C_INIT}"
			PERMISSIONS ${CONDOR_SCRIPT_PERMS}
			RENAME		condor)

endif()
else()
						 
    add_custom_command ( OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/condor_config.win
						 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
						 COMMAND awk
						 ARGS -f convert_config_to_win32.awk condor_config.generic > "${CMAKE_CURRENT_BINARY_DIR}/condor_config.win"
					   )
						 
	add_custom_target(	patch_configurations
						ALL
						DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/condor_config.win)
						
	install(FILES		${CMAKE_CURRENT_BINARY_DIR}/condor_config.win
			DESTINATION	"${C_ETC}"
			RENAME		condor_config.generic
	        )
			
	install(FILES
	        condor_config.power
	        condor_config.submit.generic
	        condor_config.local.generic
	        condor_config.local.credd 
	        condor_config.local.central.manager
	        convert_config_to_win32.awk
			DESTINATION	"${C_ETC}")


endif(NOT WINDOWS)

=== src/condor_gridmanager/CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright 2011 Red Hat, Inc. 
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 


if(NOT WIN_EXEC_NODE_ONLY)

	if ( LINUX )
		file( GLOB RmvSrcs *_gahp_wrapper* )
	elseif( DARWIN OR WINDOWS )
		file( GLOB RmvSrcs *_gahp_wrapper* *dcloud* )
	else()
		file( GLOB RmvSrcs *_gahp_wrapper* *dcloud* *ec2* *gce* )
	endif()
	condor_glob( GMHDRS GMSRCS "${RmvSrcs}" )

	if ( LINUX )
                if ( NOT LIBUUID_FOUND )
			message(FATAL_ERROR "gridmanager requires uuid library")
		endif()
		if ( NOT HAVE_UUID_UUID_H )
			message(FATAL_ERROR "gridmanager requires uuid header")
		endif()
		include_directories("${HAVE_UUID_UUID_H}")
		condor_exe( condor_gridmanager "${GMHDRS};${GMSRCS}" ${C_SBIN} "${CONDOR_TOOL_LIBS};${LIBUUID_FOUND}" OFF )
	else()
		condor_exe( condor_gridmanager "${GMHDRS};${GMSRCS}" ${C_SBIN} "${CONDOR_TOOL_LIBS}" OFF )
	endif()

	if (NOT WINDOWS)
        if (HAVE_EXT_GLOBUS)
            add_custom_target( grid_monitor
                ALL cat ${CMAKE_CURRENT_SOURCE_DIR}/grid_monitor_wrapper ${CMAKE_CURRENT_SOURCE_DIR}/grid_manager_monitor_agent > "${CMAKE_CURRENT_BINARY_DIR}/grid_monitor" && chmod 755 "${CMAKE_CURRENT_BINARY_DIR}/grid_monitor"
                DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/grid_monitor_wrapper ${CMAKE_CURRENT_SOURCE_DIR}/grid_manager_monitor_agent
            )
            install (FILES "${CMAKE_CURRENT_BINARY_DIR}/grid_monitor" DESTINATION ${C_SBIN} PERMISSIONS ${CONDOR_SCRIPT_PERMS} )
	    # CRUFT: grid_monitor.sh was renamed to grid_monitor in
	    #   Condor 7.7.6. The default in the config file was changed as
	    #   well. But we keep a symlink for the old location for
	    #   installations upgrading from older versions. This should
	    #   be removed eventually.
	    clone_install(grid_monitor "${C_SBIN}" "grid_monitor.sh" "${C_SBIN}")
        endif()

        if (HAVE_EXT_UNICOREGAHP)
            condor_exe( unicore_gahp "unicore_gahp_wrapper.cpp" ${C_SBIN} "${CONDOR_TOOL_LIBS}" OFF )
        endif()

        if (HAVE_EXT_BLAHP)
            install (FILES
                nqs_cancel.sh
                nqs_hold.sh
                nqs_resume.sh
                nqs_status.sh
                nqs_submit.sh
                DESTINATION ${C_LIBEXEC}/glite/bin
                PERMISSIONS ${CONDOR_SCRIPT_PERMS} )
        endif()

	install (FILES remote_gahp DESTINATION ${C_SBIN} PERMISSIONS ${CONDOR_SCRIPT_PERMS} )

	endif()

endif(NOT WIN_EXEC_NODE_ONLY)

=== src/condor_had/CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright 2011 Red Hat, Inc. 
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 

if (NOT WIN_EXEC_NODE_ONLY)

	condor_selective_glob("StateMachine.*;HAD.*;Utils.*" HADSrcs)

	condor_exe(condor_had "${HADSrcs}" ${C_SBIN} "${PCRE_FOUND};${CONDOR_LIBS}" ON)

	condor_selective_glob("AbstractReplicatorStateMachine.*;ReplicatorStateMachine.*;HAD_Version.*;Utils.*;Replication.*;FilesOperations.*" RepSrcs)

	condor_exe(condor_replication "${RepSrcs}" ${C_SBIN} "${PCRE_FOUND};${CONDOR_LIBS}" OFF)

	condor_selective_glob("BaseReplicaTransferer.*;UploadReplicaTransferer.*;DownloadReplicaTransferer.*;Utils.*;Transferer.*;FilesOperations.*" TransferSrcs)

	condor_exe(condor_transferer "${TransferSrcs}" ${C_LIBEXEC} "${PCRE_FOUND};${CONDOR_LIBS}" OFF)

endif(NOT WIN_EXEC_NODE_ONLY)

=== src/condor_io/CMakeLists.txt ===
 ###############################################################
 # 
 # Copyright 2011 Red Hat, Inc. 
 # 
 # Licensed under the Apache License, Version 2.0 (the "License"); you 
 # may not use this file except in compliance with the License.  You may 
 # obtain a copy of the License at 
 # 
 #    http://www.apache.org/licenses/LICENSE-2.0 
 # 
 # Unless required by applicable law or agreed to in writing, software 
 # distributed under the License is distributed on an "AS IS" BASIS, 
 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 # See the License for the specific language governing permissions and 
 # limitations under the License. 
 # 
 ############################################################### 


file( GLOB CeadarRmvSrcs *.t* test.h )
condor_glob( CedarHdrs CedarSrcs "${CeadarRmvSrcs}" )

set( CEDAR_UTIL_SRCS "${CedarHdrs};${CedarSrcs}" PARENT_SCOPE )

if (NOT WINDOWS)
	condor_exe_test(cedar_test.exe "cedar.t.unix.cpp" "${CONDOR_TOOL_LIBS}")
endif()

=== debian/changelog ===
condor (8.4.2~dfsg.1-1build1) xenial; urgency=medium

  * No-change rebuild for gsoap transition.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 22 Feb 2016 07:23:31 +0000

condor (8.4.2~dfsg.1-1) unstable; urgency=medium

  * New upstream release.
    - Simplified configuration to hold or preempt jobs that exceed resource
      claims.
    - Fix FTBFS on non-amd64 64bit platforms (Closes: #804386).
    - Various other bug fixes.
  * Install tmpfiles configuration for systemd to prevent service start
    failure due to missing /var/run/condor.

 -- Michael Hanke <mih@debian.org>  Fri, 11 Dec 2015 20:30:35 +0100

=== debian/control ===
Source: condor
Maintainer: HTCondor Developers <condor-debian@cs.wisc.edu>
Uploaders: Michael Hanke <mih@debian.org>,
           Brian Lin <blin@cs.wisc.edu>
Section: science
Priority: extra
Build-Depends: autotools-dev,
               chrpath,
               cmake,
               debhelper (>= 9~),
               default-jdk | gcj-jdk,
               dh-autoreconf,
               gsoap (>= 2.7.17-1~),
               help2man,
               latex2html,
               libboost-filesystem-dev,
               libboost-program-options-dev,
               libboost-python-dev,
               libboost-regex-dev,
               libboost-system-dev,
               libboost-test-dev,
               libboost-thread-dev,
               libcgroup-dev,
               libcurl4-openssl-dev,
               libexpat1-dev,
               libglobus-ftp-client-dev,
               libglobus-gass-server-ez-dev,
               libglobus-gram-client-dev,
               libglobus-gram-protocol-dev,
               libglobus-gss-assist-dev,
               libkrb5-dev,
               libldap2-dev | libldap-dev,
               libpcre3-dev,
               libpq-dev,
               libvirt-dev,
               libx11-dev,
               libxml2-dev,
               po-debconf,
               python-dev,
               transfig,
               uuid-dev,
               voms-dev,
               zlib1g-dev
Standards-Version: 3.9.6
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-exppsy/condor.git
Vcs-Git: git://anonscm.debian.org/pkg-exppsy/condor.git
Homepage: http://research.cs.wisc.edu/htcondor

Package: htcondor
Architecture: any
Depends: adduser,
         debconf | debconf-2.0,
         libdate-manip-perl,
         python,
         libclassad7 (= ${binary:Version}),
         ${misc:Depends},
         ${perl:Depends},
         ${python:Depends},
         ${shlibs:Depends}
Recommends: dmtcp, ecryptfs-utils
Suggests: docker, coop-computing-tools
Breaks: condor (<< 8.0.5~)
Replaces: condor (<< 8.0.5~)
Description: distributed workload management system
 Like other full-featured batch systems, HTCondor provides a job queueing
 mechanism, scheduling policy, priority scheme, resource monitoring, and
 resource management. Users submit their serial or parallel jobs to HTCondor;
 HTCondor places them into a queue. It chooses when and where to run the jobs
 based upon a policy, carefully monitors their progress, and ultimately
 informs the user upon completion.
 .
 Unlike more traditional batch queueing systems, HTCondor can also effectively
 harness wasted CPU power from otherwise idle desktop workstations. HTCondor
 does not require a shared file system across machines - if no shared file
 system is available, HTCondor can transfer the job's data files on behalf of
 the user.
 .
 This package can set up an appropriate initial configuration at install
 time for a machine intended either as a member of an existing HTCondor pool
 or as a "Personal" (single machine) HTCondor pool.

Package: htcondor-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: condor-dev (<< 8.0.5~)
Replaces: condor-dev (<< 8.0.5~)
Description: distributed workload management system - development files
 Like other full-featured batch systems, HTCondor provides a job queueing
 mechanism, scheduling policy, priority scheme, resource monitoring, and
 resource management. Users submit their serial or parallel jobs to HTCondor;
 HTCondor places them into a queue. It chooses when and where to run the jobs
 based upon a policy, carefully monitors their progress, and ultimately
 informs the user upon completion.
 .
 Unlike more traditional batch queueing systems, HTCondor can also effectively
 harness wasted CPU power from otherwise idle desktop workstations. HTCondor
 does not require a shared file system across machines - if no shared file
 system is available, HTCondor can transfer the job's data files on behalf of
 the user.
 .
 This package provides headers and libraries for development of HTCondor
 add-ons.

Package: htcondor-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Breaks: condor-doc (<< 8.0.5~)
Replaces: condor-doc (<< 8.0.5~)
Description: distributed workload management system - documentation
 Like other full-featured batch systems, HTCondor provides a job queueing
 mechanism, scheduling policy, priority scheme, resource monitoring, and
 resource management. Users submit their serial or parallel jobs to HTCondor;
 HTCondor places them into a queue. It chooses when and where to run the jobs
 based upon a policy, carefully monitors their progress, and ultimately
 informs the user upon completion.
 .
 Unlike more traditional batch queueing systems, HTCondor can also effectively
 harness wasted CPU power from otherwise idle desktop workstations. HTCondor
 does not require a shared file system across machines - if no shared file
 system is available, HTCondor can transfer the job's data files on behalf of
 the user.
 .
 This package provides HTCondor's documentation in HTML and PDF format, as well
 as configuration and other examples.

Package: htcondor-dbg
Architecture: any
Section: debug
Depends: htcondor (= ${binary:Version}),
         ${misc:Depends}
Breaks: condor-dbg (<< 8.0.5~)
Replaces: condor-dbg (<< 8.0.5~)
Description: distributed workload management system - debugging symbols
 Like other full-featured batch systems, HTCondor provides a job queueing
 mechanism, scheduling policy, priority scheme, resource monitoring, and
 resource management. Users submit their serial or parallel jobs to HTCondor;
 HTCondor places them into a queue. It chooses when and where to run the jobs
 based upon a policy, carefully monitors their progress, and ultimately
 informs the user upon completion.
 .
 Unlike more traditional batch queueing systems, HTCondor can also effectively
 harness wasted CPU power from otherwise idle desktop workstations. HTCondor
 does not require a shared file system across machines - if no shared file
 system is available, HTCondor can transfer the job's data files on behalf of
 the user.
 .
 This package provides the debugging symbols for HTCondor.

Package: libclassad-dev
Architecture: any
Section: libdevel
Depends: libclassad7 (= ${binary:Version}),
         ${misc:Depends}
Conflicts: libclassad0-dev
Replaces: libclassad0-dev
Description: HTCondor classads expression language - development library
 Classified Advertisements (classads) are the lingua franca of HTCondor, used
 for describing jobs, workstations, and other resources. There is a protocol
 for evaluating whether two classads match, which is used by the HTCondor
 central manager to determine the compatibility of jobs, and workstations where
 they may be run.
 .
 This package provides the static library and header files.

Package: libclassad7
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: HTCondor classads expression language - runtime library
 Classified Advertisements (classads) are the lingua franca of HTCondor, used
 for describing jobs, workstations, and other resources. There is a protocol
 for evaluating whether two classads match, which is used by the HTCondor
 central manager to determine the compatibility of jobs, and workstations where
 they may be run.
 .
 This package provides the runtime library.

Package: condor
Architecture: all
Section: oldlibs
Depends: htcondor,
         ${misc:Depends}
Description: transitional dummy package
 This package aids upgrades of existing Condor installations to the new project
 and package name "HTCondor". The package is empty and it can safely be
 removed.

Package: condor-doc
Architecture: all
Section: oldlibs
Depends: htcondor-doc,
         ${misc:Depends}
Description: transitional dummy package
 This package aids upgrades of existing Condor installations to the new project
 and package name "HTCondor". The package is empty and it can safely be
 removed.

Package: condor-dev
Architecture: all
Section: oldlibs
Depends: htcondor-dev,
         ${misc:Depends}
Description: transitional dummy package
 This package aids upgrades of existing Condor installations to the new project
 and package name "HTCondor". The package is empty and it can safely be
 removed.

Package: condor-dbg
Architecture: all
Section: oldlibs
Depends: htcondor-dbg,
         ${misc:Depends}
Description: transitional dummy package
 This package aids upgrades of existing Condor installations to the new project
 and package name "HTCondor". The package is empty and it can safely be
 removed.

=== debian/rules ===
#!/usr/bin/make -f

srcpkg = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Source:' | cut -d ' ' -f 2,2)
debver = $(shell LC_ALL=C dpkg-parsechangelog | grep '^Version:' | cut -d ' ' -f 2,2 )
upstreamver = $(shell echo $(debver) | cut -d '-' -f 1,1 )

# this figures out the last merge point from 'master' into the Debian branch and
# then described this commit relative to the last release tag (V...)
# If this should make any sense the local upstream branch must track upstream's
# master or whatever other source branch.
gitver = $(shell [ -x /usr/bin/git ] && git describe --tags --match 'V[0-9]_[0-9]_[0-9]' $$(git merge-base -a HEAD upstream) | sed -e 's/^V//' -e 's/_/./g' -e 's/-/+git/')~dfsg.1

# one ring to rule them all ...
%:
	dh $@ --with autotools_dev --with python2


override_dh_auto_configure:
	dh_auto_configure -- \
		-DCONDOR_PACKAGE_BUILD:BOOL=ON \
		-DPROPER:BOOL=ON \
		-DCLIPPED:BOOL=ON \
		-DUW_BUILD:BOOL=OFF \
		-D_DEBUG:BOOL=TRUE \
		-DBUILDID:STRING="Debian-$(debver)"\
		-DFORCE_PRE_RELEASE:STRING="Debian-$(debver)"\
		-DCMAKE_INSTALL_RPATH:STRING="/usr/lib/condor" \
		-DHAVE_EXT_GSOAP:BOOL=ON \
		-DHAVE_EXT_CURL:BOOL=ON \
		-DHAVE_EXT_OPENSSL:BOOL=ON \
		-DHAVE_EXT_BOOST:BOOL=ON \
		-DHAVE_EXT_GLOBUS:BOOL=ON \
		-DHAVE_EXT_KRB5:BOOL=ON \
		-DHAVE_EXT_LIBVIRT:BOOL=ON \
		-DHAVE_EXT_LIBXML2:BOOL=ON \
		-DHAVE_EXT_OPENSSL:BOOL=ON \
		-DHAVE_EXT_PCRE:BOOL=ON \
		-DWITH_LIBCGROUP:BOOL=ON \
		-DWANT_CONTRIB:BOOL=OFF \
		-DWITH_BOSCO:BOOL=OFF \
		-DWITH_PYTHON_BINDINGS:BOOL=OFF \
		-DWITH_CAMPUSFACTORY:BOOL=OFF
		# upstream says: tests aren't reliable enough yet
		#-DBUILD_TESTS:BOOL=OFF \
		#-DHAVE_EXT_POSTGRESQL:BOOL=OFF \
		#-DEXTERNAL_INCLUDES:STRING="/usr/include/postgresql"


override_dh_auto_build: doc/build
	dh_auto_build -- VERBOSE=1
	# post-fixing things that have to be done due to changes introduced by
	# repackaging
	# 1. rebuild java stuff
	#cd src/condor_starter.V6.1 && javac *.java
	#cp src/condor_chirp/*.java src/condor_chirp/chirp/java/client/
	#$(MAKE) -C src/condor_chirp/chirp/java/client/
	#cp src/condor_chirp/chirp/java/client/Chirp.jar src/condor_chirp/

override_dh_python2:
	dh_python2 $@ --no-guessing-versions

override_dh_shlibdeps:
	dh_shlibdeps -l$(CURDIR)/debian/tmp/usr/lib/


doc/build:
	mkdir -p $@
	$(MAKE) -C doc release-html MANDIR=$(CURDIR)/$@/html
		TARGETDIR=$(CURDIR)/$@/html
	# remove archives
	-rm $@/html/*.Z $@/html/*.gz
	$(MAKE) -C doc/makeman makeman
	for html in $@/html/condor_*.html; do \
		doc/makeman/makeman -v -i $$html -s 1; \
	done
	mkdir -p $@/man
	# sanitize and copy
	for man in $@/html/condor_*.1; do \
		sed -r -e 's,$@/html/,,' -e "s/1 date$$/1 \"$$(date +'%B %Y')\"/" \
			   -e '/\.SH Name/{ n; n; s/\W/ \\- /; }' -e 's/ (\.[A-Z])/\1/' \
			   -e "s/($$(echo $$(basename $$man) | cut -d . -f1,1))/\1 /g" \
			   -e '/\\$$/{ n; s/\.br//; }' -e 's,/SPAN>, ,g' \
			   -e '/[ ]*\.P/{ n; s/^[ ]*\.P//; }' \
			   -e 's/^[ ]*\././' \
			   -e 's/^\s//' < $$man > $@/man/$$(basename $$man) ; \
	done
	rm $@/html/condor_*.1
	find $@/html -name '*.html.bak' -delete


override_dh_auto_install:
	dh_auto_install
	# things we do not need in Debian
	rm debian/tmp/usr/sbin/condor_install*
	# remove compat symlinks
	rm debian/tmp/usr/sbin/condor_vm_vmware.pl
	rm debian/tmp/usr/sbin/grid_monitor.sh
	# make sure to have the few binaries to carry an RPATH converted to RUNPATH
	chrpath -c -k ./debian/tmp/usr/lib/condor/*.so || true
	chrpath -c -k ./debian/tmp/usr/sbin/* || true
	chrpath -c -k ./debian/tmp/usr/lib/condor/libexec/* || true


override_dh_install:
	dh_install
	# fix permissions
	chmod -x debian/htcondor/etc/default/condor
	chmod -x debian/htcondor/usr/lib/condor/libexec/interactive.sub
	# remove RPATH from public lib
	chrpath -d debian/libclassad*/usr/lib/libclassad.so.*.*
	# remove duplicate that is also installed as a config file
	rm -f debian/htcondor/usr/lib/condor/libexec/linux-kernel-tuning


override_dh_auto_clean:
	dh_auto_clean
	# clean up our own mess
	-find $(CURDIR) -name '*.class' -delete -o -name '*.jar' -delete
	-rm src/condor_chirp/chirp/java/client/*.java
	# clean leftovers of upstream clean run
	-rm src/condor_tests/list*
	-rm src/condor_examples/condor.boot.debian \
		src/condor_examples/condor_config.patched
	-rm src/condor_tests/Condor.pm src/condor_tests/CondorPersonal.pm \
		src/condor_tests/CondorTest.pm src/condor_tests/CondorUtils.pm \
		src/condor_tests/batch_test.pl
	-rm src/condor_utils/param_info.c
	# docs
	$(MAKE) -C doc reallyclean
	-rm -f doc/condor-*-Manual.tar
	-rm -rf doc/just-man-pages
	-rm -rf doc/build
	-rm -f doc/symbol.tex doc/figuresizing.tex doc/fontsize.tex


override_dh_clean:
	dh_clean
	debconf-updatepo


# PDF come in dedicated doc package -- no compression
override_dh_compress:
	dh_compress -X.pdf


override_dh_installinit:
	dh_installinit -phtcondor --onlyscripts --noscripts


override_dh_strip:
	dh_strip --dbg-package=htcondor-dbg

override_dh_auto_test:

dfsg-source-tree:
	-quilt pop -a
	@echo "Testing for uncommited changes"
	@git diff --quiet HEAD
# remove windows binaries that come without sources
	rm -rf msconfig
# remove embedded tarballs with 3rd-party software that is
# currently not used in any way
	find . -name '*.tar.gz' -delete
	find . -name '*.tgz' -delete
# remove all java binaries
# and other stuff that will be deleted during clean runs anyway
	find $(CURDIR) -regextype posix-egrep -regex '.*(\.(jar|class|pdf)|TAGS)' -print0 \
		| xargs -0 -i git rm -f --ignore-unmatch -- {} || true
# commit any cleanup results
	@if ! git diff --quiet HEAD; then \
		git commit -e -a -m "Remove unwanted (e.g. non-DFSG-compliant) content"; \
	fi


# make orig tarball from repository content
get-orig-source: dfsg-source-tree
	# orig tarball, turn directory into something nicer
	git archive --format=tar --prefix=$(srcpkg)-$(gitver)/ HEAD | \
		gzip -9 > $(srcpkg)_$(gitver).orig.tar.gz

# check that DSC patches still apply
maint-check-dsc-patches:
	@for p in debian/patches/*-dsc-patch; \
		do echo "check $$p"; \
		patch -p1 --dry-run < $$p || exit 1 ; \
	done

=== debian/watch ===
version=3
opts="uversionmangle=s/_/./g,dversionmangle=s/~dfsg.*//,filenamemangle=s/.*\/V(\d)_(\d)_(\d).*/condor-$1.$2.$3\.tar\.gz/" \
  http://github.com/htcondor/htcondor/tags .*archive/V(\d[\d_]+).tar.gz
